Index: svn/src/northbridge/via/cn700/northbridge.c
===================================================================
--- svn.orig/src/northbridge/via/cn700/northbridge.c
+++ svn/src/northbridge/via/cn700/northbridge.c
@@ -157,7 +157,7 @@ static void pci_domain_set_resources(dev
 
 	printk(BIOS_SPEW, "Entering cn700 pci_domain_set_resources.\n");
 
-	pci_tolm = find_pci_tolm(&dev->link[0]);
+	pci_tolm = find_pci_tolm(dev->link_list);
 	mc_dev = dev_find_device(PCI_VENDOR_ID_VIA,
 				 PCI_DEVICE_ID_VIA_CN700_MEMCTRL, 0);
 
@@ -199,7 +199,7 @@ static void pci_domain_set_resources(dev
 		ram_resource(dev, idx++, 768,
 			     (tolmk - 768 - CONFIG_VIDEO_MB * 1024));
 	}
-	assign_resources(&dev->link[0]);
+	assign_resources(dev->link_list);
 }
 
 static struct device_operations pci_domain_ops = {
@@ -212,7 +212,7 @@ static struct device_operations pci_doma
 
 static void cpu_bus_init(device_t dev)
 {
-	initialize_cpus(&dev->link[0]);
+	initialize_cpus(dev->link_list);
 }
 
 static void cpu_bus_noop(device_t dev)
Index: svn/src/northbridge/via/cx700/northbridge.c
===================================================================
--- svn.orig/src/northbridge/via/cx700/northbridge.c
+++ svn/src/northbridge/via/cx700/northbridge.c
@@ -87,7 +87,7 @@ static void pci_domain_set_resources(dev
 	unsigned char rambits;
 	int idx;
 
-	pci_tolm = find_pci_tolm(&dev->link[0]);
+	pci_tolm = find_pci_tolm(dev->link_list);
 	mc_dev = dev_find_device(PCI_VENDOR_ID_VIA, 0x3324, 0);
 
 	rambits = pci_read_config8(mc_dev, 0x88);
@@ -128,7 +128,7 @@ static void pci_domain_set_resources(dev
 	/* TODO: Hole needed? Should this go elsewhere? */
 	ram_resource(dev, idx++, 0, 640);	/* first 640k */
 	ram_resource(dev, idx++, 768, (tolmk - 768));	/* leave a hole for vga */
-	assign_resources(&dev->link[0]);
+	assign_resources(dev->link_list);
 }
 
 static struct device_operations pci_domain_ops = {
@@ -141,7 +141,7 @@ static struct device_operations pci_doma
 
 static void cpu_bus_init(device_t dev)
 {
-	initialize_cpus(&dev->link[0]);
+	initialize_cpus(dev->link_list);
 }
 
 static void cpu_bus_noop(device_t dev)
Index: svn/src/northbridge/via/vt8601/northbridge.c
===================================================================
--- svn.orig/src/northbridge/via/vt8601/northbridge.c
+++ svn/src/northbridge/via/vt8601/northbridge.c
@@ -98,8 +98,8 @@ static void pci_domain_set_resources(dev
 	device_t mc_dev;
         uint32_t pci_tolm;
 
-        pci_tolm = find_pci_tolm(&dev->link[0]);
-	mc_dev = dev->link[0].children;
+        pci_tolm = find_pci_tolm(dev->link_list);
+	mc_dev = dev->link_list->children;
 	if (mc_dev) {
 		unsigned long tomk, tolmk;
 		unsigned char rambits;
@@ -140,7 +140,7 @@ static void pci_domain_set_resources(dev
 		idx = 10;
 		ram_resource(dev, idx++, 0, tolmk);
 	}
-	assign_resources(&dev->link[0]);
+	assign_resources(dev->link_list);
 }
 
 static struct device_operations pci_domain_ops = {
@@ -153,7 +153,7 @@ static struct device_operations pci_doma
 
 static void cpu_bus_init(device_t dev)
 {
-        initialize_cpus(&dev->link[0]);
+        initialize_cpus(dev->link_list);
 }
 
 static void cpu_bus_noop(device_t dev)
Index: svn/src/northbridge/via/vt8623/northbridge.c
===================================================================
--- svn.orig/src/northbridge/via/vt8623/northbridge.c
+++ svn/src/northbridge/via/vt8623/northbridge.c
@@ -158,8 +158,8 @@ static void pci_domain_set_resources(dev
 
 	printk(BIOS_SPEW, "Entering vt8623 pci_domain_set_resources.\n");
 
-        pci_tolm = find_pci_tolm(&dev->link[0]);
-	mc_dev = dev->link[0].children;
+        pci_tolm = find_pci_tolm(dev->link_list);
+	mc_dev = dev->link_list->children;
 	if (mc_dev) {
 		unsigned long tomk, tolmk;
 		unsigned char rambits;
@@ -201,7 +201,7 @@ static void pci_domain_set_resources(dev
 		ram_resource(dev, idx++, 0, 640);		/* first 640k */
 		ram_resource(dev, idx++, 768, tolmk - 768);	/* leave a hole for vga */
 	}
-	assign_resources(&dev->link[0]);
+	assign_resources(dev->link_list);
 }
 
 static struct device_operations pci_domain_ops = {
@@ -214,7 +214,7 @@ static struct device_operations pci_doma
 
 static void cpu_bus_init(device_t dev)
 {
-        initialize_cpus(&dev->link[0]);
+        initialize_cpus(dev->link_list);
 }
 
 static void cpu_bus_noop(device_t dev)
Index: svn/src/northbridge/via/vx800/northbridge.c
===================================================================
--- svn.orig/src/northbridge/via/vx800/northbridge.c
+++ svn/src/northbridge/via/vx800/northbridge.c
@@ -128,7 +128,7 @@ static void pci_domain_set_resources(dev
 
 	printk(BIOS_SPEW, "Entering vx800 pci_domain_set_resources.\n");
 
-	pci_tolm = find_pci_tolm(&dev->link[0]);
+	pci_tolm = find_pci_tolm(dev->link_list);
 	mc_dev = dev_find_device(PCI_VENDOR_ID_VIA,
 				 PCI_DEVICE_ID_VIA_VX855_MEMCTRL, 0);
 
@@ -175,7 +175,7 @@ if register with invalid value we set fr
 		/* Leave a hole for vga, 0xa0000 - 0xc0000 */
 		ram_resource(dev, idx++, 768, (tolmk - 768));
 	}
-	assign_resources(&dev->link[0]);
+	assign_resources(dev->link_list);
 }
 
 static struct device_operations pci_domain_ops = {
@@ -188,7 +188,7 @@ static struct device_operations pci_doma
 
 static void cpu_bus_init(device_t dev)
 {
-	initialize_cpus(&dev->link[0]);
+	initialize_cpus(dev->link_list);
 }
 
 static void cpu_bus_noop(device_t dev)
Index: svn/src/southbridge/amd/amd8131/amd8131_bridge.c
===================================================================
--- svn.orig/src/southbridge/amd/amd8131/amd8131_bridge.c
+++ svn/src/southbridge/amd/amd8131/amd8131_bridge.c
@@ -25,7 +25,7 @@ static void amd8131_walk_children(struct
 			continue;
 		}
 		if (child->hdr_type == PCI_HEADER_TYPE_BRIDGE) {
-			amd8131_walk_children(&child->link[0], visit, ptr);
+			amd8131_walk_children(child->link_list, visit, ptr);
 		}
 		visit(child, ptr);
 	}
Index: svn/src/southbridge/amd/amd8132/amd8132_bridge.c
===================================================================
--- svn.orig/src/southbridge/amd/amd8132/amd8132_bridge.c
+++ svn/src/southbridge/amd/amd8132/amd8132_bridge.c
@@ -47,7 +47,7 @@ static void amd8132_walk_children(struct
 			continue;
 		}
 		if (child->hdr_type == PCI_HEADER_TYPE_BRIDGE) {
-			amd8132_walk_children(&child->link[0], visit, ptr);
+			amd8132_walk_children(child->link_list, visit, ptr);
 		}
 		visit(child, ptr);
 	}
Index: svn/src/southbridge/amd/sb600/sb600_lpc.c
===================================================================
--- svn.orig/src/southbridge/amd/sb600/sb600_lpc.c
+++ svn/src/southbridge/amd/sb600/sb600_lpc.c
@@ -106,7 +106,7 @@ static void sb600_lpc_read_resources(dev
  */
 static void sb600_lpc_enable_childrens_resources(device_t dev)
 {
-	u32 link;
+	struct bus *link;
 	u32 reg, reg_x;
 	int var_num = 0;
 	u16 reg_var[3];
@@ -114,9 +114,9 @@ static void sb600_lpc_enable_childrens_r
 	reg = pci_read_config32(dev, 0x44);
 	reg_x = pci_read_config32(dev, 0x48);
 
-	for (link = 0; link < dev->links; link++) {
+	for (link = dev->link_list; link; link = link->next) {
 		device_t child;
-		for (child = dev->link[link].children; child;
+		for (child = link->children; child;
 		     child = child->sibling) {
 			enable_resources(child);
 			if (child->enabled
Index: svn/src/southbridge/amd/sb700/sb700_lpc.c
===================================================================
--- svn.orig/src/southbridge/amd/sb700/sb700_lpc.c
+++ svn/src/southbridge/amd/sb700/sb700_lpc.c
@@ -118,7 +118,7 @@ static void sb700_lpc_set_resources(stru
  */
 static void sb700_lpc_enable_childrens_resources(device_t dev)
 {
-	u32 link;
+	struct bus *link;
 	u32 reg, reg_x;
 	int var_num = 0;
 	u16 reg_var[3];
@@ -126,9 +126,9 @@ static void sb700_lpc_enable_childrens_r
 	reg = pci_read_config32(dev, 0x44);
 	reg_x = pci_read_config32(dev, 0x48);
 
-	for (link = 0; link < dev->links; link++) {
+	for (link = dev->link_list; link; link = link->next) {
 		device_t child;
-		for (child = dev->link[link].children; child;
+		for (child = link->children; child;
 		     child = child->sibling) {
 			enable_resources(child);
 			if (child->enabled
Index: svn/src/southbridge/broadcom/bcm5785/bcm5785_lpc.c
===================================================================
--- svn.orig/src/southbridge/broadcom/bcm5785/bcm5785_lpc.c
+++ svn/src/southbridge/broadcom/bcm5785/bcm5785_lpc.c
@@ -67,14 +67,14 @@ static void bcm5785_lpc_read_resources(d
  */
 static void bcm5785_lpc_enable_childrens_resources(device_t dev)
 {
-        unsigned link;
+	struct bus *link;
 	uint32_t reg;
 
 	reg = pci_read_config8(dev, 0x44);
 
-        for (link = 0; link < dev->links; link++) {
+	for (link = dev->link_list; link; link = link->next) {
                 device_t child;
-                for (child = dev->link[link].children; child; child = child->sibling) {
+                for (child = link->children; child; child = child->sibling) {
                         enable_resources(child);
 			if(child->enabled && (child->path.type == DEVICE_PATH_PNP)) {
 				struct resource *res;
Index: svn/src/southbridge/intel/i82801gx/i82801gx_pci.c
===================================================================
--- svn.orig/src/southbridge/intel/i82801gx/i82801gx_pci.c
+++ svn/src/southbridge/intel/i82801gx/i82801gx_pci.c
@@ -100,10 +100,10 @@ static void ich_pci_bus_enable_resources
 	/* enable IO in command register if there is VGA card
 	 * connected with (even it does not claim IO resource)
 	 */
-	if (dev->link[0].bridge_ctrl & PCI_BRIDGE_CTL_VGA)
+	if (dev->link_list->bridge_ctrl & PCI_BRIDGE_CTL_VGA)
 		dev->command |= PCI_COMMAND_IO;
 	ctrl = pci_read_config16(dev, PCI_BRIDGE_CONTROL);
-	ctrl |= dev->link[0].bridge_ctrl;
+	ctrl |= dev->link_list->bridge_ctrl;
 	ctrl |= (PCI_BRIDGE_CTL_PARITY + PCI_BRIDGE_CTL_SERR); /* error check */
 	printk(BIOS_DEBUG, "%s bridge ctrl <- %04x\n", dev_path(dev), ctrl);
 	pci_write_config16(dev, PCI_BRIDGE_CONTROL, ctrl);
Index: svn/src/southbridge/intel/pxhd/pxhd_bridge.c
===================================================================
--- svn.orig/src/southbridge/intel/pxhd/pxhd_bridge.c
+++ svn/src/southbridge/intel/pxhd/pxhd_bridge.c
@@ -41,8 +41,7 @@ static unsigned int pxhd_scan_bridge(dev
 {
 	int bus_100Mhz = 0;
 
-	dev->link[0].dev = dev;
-	dev->links = 1;
+	dev->link_list->dev = dev;
 
 	get_option(&bus_100Mhz, "pxhd_bus_speed_100");
 	if(bus_100Mhz) {
@@ -58,7 +57,7 @@ static unsigned int pxhd_scan_bridge(dev
 		pci_write_config16(dev, 0x40, word);
 
 		/* reset the bus to make the new frequencies effective */
-		pci_bus_reset(&dev->link[0]);
+		pci_bus_reset(dev->link_list);
 	}
 	return pcix_scan_bridge(dev, max);
 }
Index: svn/src/southbridge/nvidia/ck804/ck804_lpc.c
===================================================================
--- svn.orig/src/southbridge/nvidia/ck804/ck804_lpc.c
+++ svn/src/southbridge/nvidia/ck804/ck804_lpc.c
@@ -231,15 +231,15 @@ static void ck804_lpc_read_resources(dev
  */
 static void ck804_lpc_enable_childrens_resources(device_t dev)
 {
-	unsigned link;
+	struct bus *link;
 	uint32_t reg, reg_var[4];
 	int i, var_num = 0;
 
 	reg = pci_read_config32(dev, 0xa0);
 
-	for (link = 0; link < dev->links; link++) {
+	for (link = dev->link_list; link; link = link->next) {
 		device_t child;
-		for (child = dev->link[link].children; child; child = child->sibling) {
+		for (child = link->children; child; child = child->sibling) {
 			enable_resources(child);
 			if (child->enabled && (child->path.type == DEVICE_PATH_PNP)) {
 				struct resource *res;
Index: svn/src/southbridge/nvidia/ck804/ck804_smbus.c
===================================================================
--- svn.orig/src/southbridge/nvidia/ck804/ck804_smbus.c
+++ svn/src/southbridge/nvidia/ck804/ck804_smbus.c
@@ -23,7 +23,7 @@ static int lsmbus_recv_byte(device_t dev
 	device = dev->path.i2c.device;
 	pbus = get_pbus_smbus(dev);
 
-	res = find_resource(pbus->dev, 0x20 + (pbus->link * 4));
+	res = find_resource(pbus->dev, 0x20 + (pbus->link_num * 4));
 
 	return do_smbus_recv_byte(res->base, device);
 }
@@ -37,7 +37,7 @@ static int lsmbus_send_byte(device_t dev
 	device = dev->path.i2c.device;
 	pbus = get_pbus_smbus(dev);
 
-	res = find_resource(pbus->dev, 0x20 + (pbus->link * 4));
+	res = find_resource(pbus->dev, 0x20 + (pbus->link_num * 4));
 
 	return do_smbus_send_byte(res->base, device, val);
 }
@@ -51,7 +51,7 @@ static int lsmbus_read_byte(device_t dev
 	device = dev->path.i2c.device;
 	pbus = get_pbus_smbus(dev);
 
-	res = find_resource(pbus->dev, 0x20 + (pbus->link * 4));
+	res = find_resource(pbus->dev, 0x20 + (pbus->link_num * 4));
 
 	return do_smbus_read_byte(res->base, device, address);
 }
@@ -65,7 +65,7 @@ static int lsmbus_write_byte(device_t de
 	device = dev->path.i2c.device;
 	pbus = get_pbus_smbus(dev);
 
-	res = find_resource(pbus->dev, 0x20 + (pbus->link * 4));
+	res = find_resource(pbus->dev, 0x20 + (pbus->link_num * 4));
 
 	return do_smbus_write_byte(res->base, device, address, val);
 }
Index: svn/src/southbridge/nvidia/mcp55/mcp55_lpc.c
===================================================================
--- svn.orig/src/southbridge/nvidia/mcp55/mcp55_lpc.c
+++ svn/src/southbridge/nvidia/mcp55/mcp55_lpc.c
@@ -205,16 +205,16 @@ static void mcp55_lpc_read_resources(dev
  */
 static void mcp55_lpc_enable_childrens_resources(device_t dev)
 {
-	unsigned link;
 	uint32_t reg, reg_var[4];
 	int i;
 	int var_num = 0;
+	struct bus *link;
 
 	reg = pci_read_config32(dev, 0xa0);
 
-	for (link = 0; link < dev->links; link++) {
+	for (link = dev->link_list; link; link = link->next) {
 		device_t child;
-		for (child = dev->link[link].children; child; child = child->sibling) {
+		for (child = link->children; child; child = child->sibling) {
 			enable_resources(child);
 			if(child->enabled && (child->path.type == DEVICE_PATH_PNP)) {
 				struct resource *res;
Index: svn/src/southbridge/nvidia/mcp55/mcp55_smbus.c
===================================================================
--- svn.orig/src/southbridge/nvidia/mcp55/mcp55_smbus.c
+++ svn/src/southbridge/nvidia/mcp55/mcp55_smbus.c
@@ -41,7 +41,7 @@ static int lsmbus_recv_byte(device_t dev
 	device = dev->path.i2c.device;
 	pbus = get_pbus_smbus(dev);
 
-	res = find_resource(pbus->dev, 0x20 + (pbus->link * 4));
+	res = find_resource(pbus->dev, 0x20 + (pbus->link_num * 4));
 
 	return do_smbus_recv_byte(res->base, device);
 }
@@ -55,7 +55,7 @@ static int lsmbus_send_byte(device_t dev
 	device = dev->path.i2c.device;
 	pbus = get_pbus_smbus(dev);
 
-	res = find_resource(pbus->dev, 0x20 + (pbus->link * 4));
+	res = find_resource(pbus->dev, 0x20 + (pbus->link_num * 4));
 
 	return do_smbus_send_byte(res->base, device, val);
 }
@@ -69,7 +69,7 @@ static int lsmbus_read_byte(device_t dev
 	device = dev->path.i2c.device;
 	pbus = get_pbus_smbus(dev);
 
-	res = find_resource(pbus->dev, 0x20 + (pbus->link * 4));
+	res = find_resource(pbus->dev, 0x20 + (pbus->link_num * 4));
 
 	return do_smbus_read_byte(res->base, device, address);
 }
@@ -83,7 +83,7 @@ static int lsmbus_write_byte(device_t de
 	device = dev->path.i2c.device;
 	pbus = get_pbus_smbus(dev);
 
-	res = find_resource(pbus->dev, 0x20 + (pbus->link * 4));
+	res = find_resource(pbus->dev, 0x20 + (pbus->link_num * 4));
 
 	return do_smbus_write_byte(res->base, device, address, val);
 }
Index: svn/src/southbridge/sis/sis966/sis966_lpc.c
===================================================================
--- svn.orig/src/southbridge/sis/sis966/sis966_lpc.c
+++ svn/src/southbridge/sis/sis966/sis966_lpc.c
@@ -198,16 +198,16 @@ static void sis966_lpc_read_resources(de
  */
 static void sis966_lpc_enable_childrens_resources(device_t dev)
 {
-	unsigned link;
+	struct bus *link;
 	uint32_t reg, reg_var[4];
 	int i;
 	int var_num = 0;
 
 	reg = pci_read_config32(dev, 0xa0);
 
-	for (link = 0; link < dev->links; link++) {
+	for (link = dev->link_list; link; link = link->next) {
 		device_t child;
-		for (child = dev->link[link].children; child; child = child->sibling) {
+		for (child = link->children; child; child = child->sibling) {
 			enable_resources(child);
 			if(child->enabled && (child->path.type == DEVICE_PATH_PNP)) {
 				struct resource *res;
Index: svn/util/sconfig/main.c
===================================================================
--- svn.orig/util/sconfig/main.c
+++ svn/util/sconfig/main.c
@@ -278,10 +278,14 @@ void add_register(struct device *dev, ch
 }
 
 static void pass0(FILE *fil, struct device *ptr) {
+	if (ptr->type == device && ptr->id == 0)
+		fprintf(fil, "struct bus %s_links[];\n", ptr->name);
 	if ((ptr->type == device) && (ptr->id != 0) && (!ptr->used)) {
 		fprintf(fil, "struct device %s;\n", ptr->name);
 		if (ptr->rescnt > 0)
 			fprintf(fil, "struct resource %s_res[];\n", ptr->name);
+		if (ptr->children || ptr->multidev)
+			fprintf(fil, "struct bus %s_links[];\n", ptr->name);
 	}
 	if ((ptr->type == device) && (ptr->id != 0) && ptr->used)
 		fprintf(fil, "struct device %s;\n", ptr->aliased_name);
@@ -291,7 +295,7 @@ static void pass1(FILE *fil, struct devi
 	if (!ptr->used && (ptr->type == device)) {
 		fprintf(fil, "struct device %s = {\n", ptr->name);
 		fprintf(fil, "\t.ops = %s,\n", (ptr->ops)?(ptr->ops):"0");
-		fprintf(fil, "\t.bus = &%s.link[%d],\n", ptr->bus->name, ptr->bus->link);
+		fprintf(fil, "\t.bus = &%s_links[%d],\n", ptr->bus->name, ptr->bus->link);
 		fprintf(fil, "\t.path = {");
 		fprintf(fil, ptr->path, ptr->path_a, ptr->path_b);
 		fprintf(fil, "},\n");
@@ -301,33 +305,10 @@ static void pass1(FILE *fil, struct devi
 			fprintf(fil, "\t.resource_list = &%s_res[0],\n", ptr->name);
 		}
 		int link = 0;
-		fprintf(fil, "\t.link = {\n");
-		if (ptr->multidev) {
-			struct device *d = ptr;
-			while (d) {
-				if (device_match(d, ptr)) {
-					fprintf(fil, "\t\t[%d] = {\n", d->link);
-					fprintf(fil, "\t\t\t.link = %d,\n", d->link);
-					fprintf(fil, "\t\t\t.dev = &%s,\n", d->name);
-					if (d->children)
-						fprintf(fil, "\t\t\t.children = &%s,\n", d->children->name);
-					fprintf(fil, "\t\t},\n");
-					link++;
-				}
-				d = d->next_sibling;
-			}
-		} else {
-			if (ptr->children) {
-				fprintf(fil, "\t\t[0] = {\n");
-				fprintf(fil, "\t\t\t.link = 0,\n");
-				fprintf(fil, "\t\t\t.dev = &%s,\n", ptr->name);
-				fprintf(fil, "\t\t\t.children = &%s,\n", ptr->children->name);
-				fprintf(fil, "\t\t},\n");
-				link++;
-			}
-		}
-		fprintf(fil, "\t},\n");
-		fprintf(fil, "\t.links = %d,\n", link);
+		if (ptr->children || ptr->multidev)
+			fprintf(fil, "\t.link_list = &%s_links[0],\n", ptr->name);
+		else
+			fprintf(fil, "\t.link_list = NULL,\n", ptr->name);
 		if (ptr->sibling)
 			fprintf(fil, "\t.sibling = &%s,\n", ptr->sibling->name);
 		if (ptr->chip->chiph_exists) {
@@ -356,6 +337,37 @@ static void pass1(FILE *fil, struct devi
 		}
 		fprintf(fil, "\t };\n");
 	}
+	if (!ptr->used && ptr->type == device && (ptr->children || ptr->multidev)) {
+		fprintf(fil, "struct bus %s_links[] = {\n", ptr->name);
+		if (ptr->multidev) {
+			struct device *d = ptr;
+			while (d) {
+				if (device_match(d, ptr)) {
+					fprintf(fil, "\t\t[%d] = {\n", d->link);
+					fprintf(fil, "\t\t\t.link_num = %d,\n", d->link);
+					fprintf(fil, "\t\t\t.dev = &%s,\n", d->name);
+					if (d->children)
+						fprintf(fil, "\t\t\t.children = &%s,\n", d->children->name);
+					if (device_match(d->next_sibling, ptr))
+						fprintf(fil, "\t\t\t.next=&%s_links[%d],\n", d->name, d->link+1);
+					else
+						fprintf(fil, "\t\t\t.next = NULL,\n");
+					fprintf(fil, "\t\t},\n");
+				}
+				d = d->next_sibling;
+			}
+		} else {
+			if (ptr->children) {
+				fprintf(fil, "\t\t[0] = {\n");
+				fprintf(fil, "\t\t\t.link_num = 0,\n");
+				fprintf(fil, "\t\t\t.dev = &%s,\n", ptr->name);
+				fprintf(fil, "\t\t\t.children = &%s,\n", ptr->children->name);
+				fprintf(fil, "\t\t\t.next = NULL,\n");
+				fprintf(fil, "\t\t},\n");
+			}
+		}
+		fprintf(fil, "\t};\n");
+	}
 	if ((ptr->type == chip) && (ptr->chiph_exists)) {
 		if (ptr->reg) {
 			fprintf(fil, "struct %s_config %s_info_%d\t= {\n", ptr->name_underscore, ptr->name_underscore, ptr->id);
Index: svn/src/mainboard/ibase/mb899/mptable.c
===================================================================
--- svn.orig/src/mainboard/ibase/mb899/mptable.c
+++ svn/src/mainboard/ibase/mb899/mptable.c
@@ -70,7 +70,7 @@ static void *smp_write_config_table(void
 	if (!riser)
 		riser = dev_find_device(0x3388, 0x0022, 0);
 	if (riser) {
-		riser_bus = riser->link[0].secondary;
+		riser_bus = riser->link_list->secondary;
 		printk(BIOS_SPEW, "Riser bus is %x\n", riser_bus);
 		max_pci_bus = riser_bus;
 	}
